/* nevars.h: this header file was produced automatically by
 * the ./mktbls program, based on input from the file ./modetbl
 */

#include <blist.h>

#if OPT_EVAL

/*	structure to hold temp variables and their definitions	*/

typedef struct UVAR {
	struct UVAR *next;
	char *u_name;		/* name of temp variable */
	char *u_value;		/* value (string) */
	char u_type;		/* type (normally string) */
} UVAR;

decl_uninit( UVAR *temp_vars );	/* temporary variables */


/*	list of recognized state variables	*/

extern BLIST blist_statevars;

#ifdef realdef
DECL_EXTERN_CONST(char *const statevars[]) = {
#if OPT_EVAL
	s____,
#endif
	s_abufname__,
#if OPT_HOOKS&&OPT_COLOR
	s_autocolor_hook__,
#endif
	s_bchanged__,
	s_bchars__,
	s_bflags__,
	s_blines__,
#if DISP_NTWIN
	s_brightness__,
#endif
#if OPT_MULTIBYTE
	s_buf_encoding__,
#endif
#if OPT_CURTOKENS
	s_buf_fname_expr__,
#endif
#if OPT_HOOKS
	s_buffer_hook__,
#endif
#if OPT_CURTOKENS
	s_bufname__,
#endif
	s_bwindows__,
	s_cbufname__,
#if OPT_HOOKS
	s_cd_hook__,
#endif
#if OPT_PATHLOOKUP
	s_cdpath__,
#endif
	s_cfgopts__,
	s_cfilname__,
	s_char__,
#if OPT_EVAL
	s_cmd_count__,
#endif
#if OPT_MULTIBYTE
	s_cmd_encoding__,
#endif
#if OPT_EVAL&&OPT_PROCEDURES
	s_cmd_motion__,
#endif
#if OPT_ENCRYPT
	s_cryptkey__,
#endif
#if !SMALLER
	s_curchar__,
#endif
	s_curcol__,
	s_curline__,
#if OPT_SHELL
	s_cwd__,
#endif
	s_cwline__,
	s_debug__,
#if OPT_SHELL
	s_directory__,
#endif
	s_discmd__,
	s_disinp__,
#if !SMALLER
	s_empty_lines__,
#endif
#if OPT_LOCALE
	s_encoding__,
#endif
	s_end_of_cmd__,
#if OPT_FINDERR
	s_error_buffer__,
	s_error_expr__,
	s_error_match__,
	s_error_tabstop__,
#endif
	s_exec_path__,
	s_exec_suffix__,
#if OPT_HOOKS
	s_exit_hook__,
#endif
#if SYS_WINNT
	s_favorites__,
#endif
#if !SMALLER
	s_fchanged__,
#endif
#if OPT_FINDERR
	s_filename_expr__,
#endif
	s_filename_ic__,
#if OPT_FILTER
	s_filter_list__,
#endif
#if OPT_FINDPATH
	s_find_cmd__,
	s_findpath__,
#endif
	s_font__,
	s_forward_search__,
	s_get_at_dot__,
	s_get_it_all__,
	s_get_length__,
	s_get_offset__,
#if OPT_TRACE
	s_goal_column__,
#endif
	s_helpfile__,
#if DISP_X11
	s_iconname__,
#endif
#if OPT_CURTOKENS
	s_identifier__,
#endif
#if OPT_MULTIBYTE
	s_kbd_encoding__,
#endif
	s_kbd_macro__,
	s_kill__,
	s_kill_limit__,
	s_kill_size__,
	s_lastkey__,
#if OPT_MULTIBYTE
	s_latin1_expr__,
#endif
	s_lcols__,
	s_libdir_path__,
	s_line__,
	s_llength__,
#if OPT_LOCALE
	s_locale__,
#endif
#if OPT_MAJORMODE
	s_majormode__,
#endif
#if OPT_HOOKS&&OPT_MAJORMODE
	s_majormode_hook__,
#endif
	s_match__,
#if OPT_MENUS
	s_menu_file__,
#endif
	s_mode__,
#if OPT_MLFORMAT
	s_modeline_format__,
#endif
#if OPT_MODELINE
	s_modeline_limit__,
#endif
	s_modified__,
	s_ncolors__,
	s_ntildes__,
#if OPT_SHELL
	s_ocwd__,
#endif
	s_os__,
	s_pagelen__,
	s_pagewid__,
	s_palette__,
	s_patchlevel__,
	s_pathlist_separator__,
#if OPT_CURTOKENS
	s_pathname__,
#endif
	s_pathname_separator__,
	s_pending__,
	s_pid__,
#if OPT_POSFORMAT
	s_position_format__,
#endif
	s_progname__,
	s_prompt__,
	s_qidentifier__,
#if OPT_HOOKS
	s_read_hook__,
#endif
	s_replace__,
#if OPT_EVAL
	s_return__,
#endif
	s_search__,
	s_seed__,
#if OPT_SHELL
	s_shell__,
#endif
	s_sres__,
	s_startup_file__,
	s_startup_path__,
	s_status__,
	s_term_cols__,
#if OPT_MULTIBYTE
	s_term_encoding__,
#endif
	s_term_lines__,
	s_term_resizes__,
#if OPT_TITLE
	s_title__,
#endif
#if OPT_MULTIBYTE&&OPT_TITLE
	s_title_encoding__,
#endif
#if OPT_TITLE
	s_title_format__,
#endif
	s_version__,
#if OPT_EVAL
	s_with_prefix__,
#endif
	s_wlines__,
	s_word__,
#if OPT_HOOKS
	s_write_hook__,
#endif
#if DISP_X11&&OPT_SHELL
	s_xdisplay__,
	s_xshell__,
	s_xshell_flags__,
#endif
	NULL	/* ends table for name-completion */
};
BLIST blist_statevars = init_blist(statevars);
#else
extern const char *const statevars[];
#endif

typedef enum {
#if OPT_EVAL
	VAR__STATUS,
#endif
	VAR_ABUFNAME,
#if OPT_HOOKS&&OPT_COLOR
	VAR_AUTOCOLORHOOK,
#endif
	VAR_BCHANGED,
	VAR_BCHARS,
	VAR_BFLAGS,
	VAR_BLINES,
#if DISP_NTWIN
	VAR_BRIGHTNESS,
#endif
#if OPT_MULTIBYTE
	VAR_BUF_ENCODING,
#endif
#if OPT_CURTOKENS
	VAR_BUF_FNAME_EXPR,
#endif
#if OPT_HOOKS
	VAR_BUFHOOK,
#endif
#if OPT_CURTOKENS
	VAR_BUFNAME,
#endif
	VAR_BWINDOWS,
	VAR_CBUFNAME,
#if OPT_HOOKS
	VAR_CDHOOK,
#endif
#if OPT_PATHLOOKUP
	VAR_CDPATH,
#endif
	VAR_CFGOPTS,
	VAR_CFNAME,
	VAR_CHAR,
#if OPT_EVAL
	VAR_CMD_COUNT,
#endif
#if OPT_MULTIBYTE
	VAR_CMD_ENCODING,
#endif
#if OPT_EVAL&&OPT_PROCEDURES
	VAR_CMD_MOTION,
#endif
#if OPT_ENCRYPT
	VAR_CRYPTKEY,
#endif
#if !SMALLER
	VAR_CURCHAR,
#endif
	VAR_CURCOL,
	VAR_CURLINE,
#if OPT_SHELL
	VAR_CWD,
#endif
	VAR_CWLINE,
	VAR_DEBUG,
#if OPT_SHELL
	VAR_DIRECTORY,
#endif
	VAR_DISCMD,
	VAR_DISINP,
#if !SMALLER
	VAR_EMPTY_LINES,
#endif
#if OPT_LOCALE
	VAR_ENCODING,
#endif
	VAR_EOC,
#if OPT_FINDERR
	VAR_ERROR_BUFFER,
	VAR_ERROR_EXPR,
	VAR_ERROR_MATCH,
	VAR_ERROR_TABSTOP,
#endif
	VAR_EXEC_PATH,
	VAR_EXEC_SUFFIX,
#if OPT_HOOKS
	VAR_EXITHOOK,
#endif
#if SYS_WINNT
	VAR_FAVORITES,
#endif
#if !SMALLER
	VAR_FCHANGED,
#endif
#if OPT_FINDERR
	VAR_FILENAME_EXPR,
#endif
	VAR_FILENAME_IC,
#if OPT_FILTER
	VAR_FILTER_LIST,
#endif
#if OPT_FINDPATH
	VAR_FINDCMD,
	VAR_FINDPATH,
#endif
	VAR_FONT,
	VAR_FWD_SEARCH,
	VAR_GET_AT_DOT,
	VAR_GET_IT_ALL,
	VAR_GET_LENGTH,
	VAR_GET_OFFSET,
#if OPT_TRACE
	VAR_GOAL_COLUMN,
#endif
	VAR_HELPFILE,
#if DISP_X11
	VAR_ICONNAME,
#endif
#if OPT_CURTOKENS
	VAR_IDENTIFIER,
#endif
#if OPT_MULTIBYTE
	VAR_KBD_ENCODING,
#endif
	VAR_KBDMACRO,
	VAR_KILL,
	VAR_KILL_LIMIT,
	VAR_KILL_SIZE,
	VAR_LASTKEY,
#if OPT_MULTIBYTE
	VAR_LATIN1_EXPR,
#endif
	VAR_LCOLS,
	VAR_LIBDIR_PATH,
	VAR_LINE,
	VAR_LLENGTH,
#if OPT_LOCALE
	VAR_LOCALE,
#endif
#if OPT_MAJORMODE
	VAR_MAJORMODE,
#endif
#if OPT_HOOKS&&OPT_MAJORMODE
	VAR_MAJORMODEHOOK,
#endif
	VAR_MATCH,
#if OPT_MENUS
	VAR_MENU_FILE,
#endif
	VAR_MODE,
#if OPT_MLFORMAT
	VAR_MLFORMAT,
#endif
#if OPT_MODELINE
	VAR_MODELINE_LIMIT,
#endif
	VAR_MODIFIED,
	VAR_NCOLORS,
	VAR_NTILDES,
#if OPT_SHELL
	VAR_OCWD,
#endif
	VAR_OS,
	VAR_PAGELEN,
	VAR_CURWIDTH,
	VAR_PALETTE,
	VAR_PATCHLEVEL,
	VAR_PATHCHR,
#if OPT_CURTOKENS
	VAR_PATHNAME,
#endif
	VAR_PATHSEP,
	VAR_PENDING,
	VAR_PROCESSID,
#if OPT_POSFORMAT
	VAR_POSFORMAT,
#endif
	VAR_PROGNAME,
	VAR_PROMPT,
	VAR_QIDENTIFIER,
#if OPT_HOOKS
	VAR_RDHOOK,
#endif
	VAR_REPLACE,
#if OPT_EVAL
	VAR_RETURN,
#endif
	VAR_SEARCH,
	VAR_SEED,
#if OPT_SHELL
	VAR_SHELL,
#endif
	VAR_SRES,
	VAR_STARTUP_FILE,
	VAR_STARTUP_PATH,
	VAR_STATUS,
	VAR_TERM_COLS,
#if OPT_MULTIBYTE
	VAR_TERM_ENCODING,
#endif
	VAR_TERM_LINES,
	VAR_TERM_RESIZES,
#if OPT_TITLE
	VAR_TITLE,
#endif
#if OPT_MULTIBYTE&&OPT_TITLE
	VAR_TITLE_ENCODING,
#endif
#if OPT_TITLE
	VAR_TITLEFORMAT,
#endif
	VAR_VERSION,
#if OPT_EVAL
	VAR_WITHPREFIX,
#endif
	VAR_WLINES,
	VAR_WORD,
#if OPT_HOOKS
	VAR_WRHOOK,
#endif
#if DISP_X11&&OPT_SHELL
	VAR_XDISPLAY,
	VAR_XSHELL,
	VAR_XSHELLFLAGS,
#endif
	Num_StateVars
} enumStateVars;


#if OPT_EVAL
int var__STATUS(TBUFF **resp, const char *valp);
#endif
int var_ABUFNAME(TBUFF **resp, const char *valp);
#if OPT_HOOKS&&OPT_COLOR
int var_AUTOCOLORHOOK(TBUFF **resp, const char *valp);
#endif
int var_BCHANGED(TBUFF **resp, const char *valp);
int var_BCHARS(TBUFF **resp, const char *valp);
int var_BFLAGS(TBUFF **resp, const char *valp);
int var_BLINES(TBUFF **resp, const char *valp);
#if DISP_NTWIN
int var_BRIGHTNESS(TBUFF **resp, const char *valp);
#endif
#if OPT_MULTIBYTE
int var_BUF_ENCODING(TBUFF **resp, const char *valp);
#endif
#if OPT_CURTOKENS
int var_BUF_FNAME_EXPR(TBUFF **resp, const char *valp);
#endif
#if OPT_HOOKS
int var_BUFHOOK(TBUFF **resp, const char *valp);
#endif
#if OPT_CURTOKENS
int var_BUFNAME(TBUFF **resp, const char *valp);
#endif
int var_BWINDOWS(TBUFF **resp, const char *valp);
int var_CBUFNAME(TBUFF **resp, const char *valp);
#if OPT_HOOKS
int var_CDHOOK(TBUFF **resp, const char *valp);
#endif
#if OPT_PATHLOOKUP
int var_CDPATH(TBUFF **resp, const char *valp);
#endif
int var_CFGOPTS(TBUFF **resp, const char *valp);
int var_CFNAME(TBUFF **resp, const char *valp);
int var_CHAR(TBUFF **resp, const char *valp);
#if OPT_EVAL
int var_CMD_COUNT(TBUFF **resp, const char *valp);
#endif
#if OPT_MULTIBYTE
int var_CMD_ENCODING(TBUFF **resp, const char *valp);
#endif
#if OPT_EVAL&&OPT_PROCEDURES
int var_CMD_MOTION(TBUFF **resp, const char *valp);
#endif
#if OPT_ENCRYPT
int var_CRYPTKEY(TBUFF **resp, const char *valp);
#endif
#if !SMALLER
int var_CURCHAR(TBUFF **resp, const char *valp);
#endif
int var_CURCOL(TBUFF **resp, const char *valp);
int var_CURLINE(TBUFF **resp, const char *valp);
#if OPT_SHELL
int var_CWD(TBUFF **resp, const char *valp);
#endif
int var_CWLINE(TBUFF **resp, const char *valp);
int var_DEBUG(TBUFF **resp, const char *valp);
#if OPT_SHELL
int var_DIRECTORY(TBUFF **resp, const char *valp);
#endif
int var_DISCMD(TBUFF **resp, const char *valp);
int var_DISINP(TBUFF **resp, const char *valp);
#if !SMALLER
int var_EMPTY_LINES(TBUFF **resp, const char *valp);
#endif
#if OPT_LOCALE
int var_ENCODING(TBUFF **resp, const char *valp);
#endif
int var_EOC(TBUFF **resp, const char *valp);
#if OPT_FINDERR
int var_ERROR_BUFFER(TBUFF **resp, const char *valp);
int var_ERROR_EXPR(TBUFF **resp, const char *valp);
int var_ERROR_MATCH(TBUFF **resp, const char *valp);
int var_ERROR_TABSTOP(TBUFF **resp, const char *valp);
#endif
int var_EXEC_PATH(TBUFF **resp, const char *valp);
int var_EXEC_SUFFIX(TBUFF **resp, const char *valp);
#if OPT_HOOKS
int var_EXITHOOK(TBUFF **resp, const char *valp);
#endif
#if SYS_WINNT
int var_FAVORITES(TBUFF **resp, const char *valp);
#endif
#if !SMALLER
int var_FCHANGED(TBUFF **resp, const char *valp);
#endif
#if OPT_FINDERR
int var_FILENAME_EXPR(TBUFF **resp, const char *valp);
#endif
int var_FILENAME_IC(TBUFF **resp, const char *valp);
#if OPT_FILTER
int var_FILTER_LIST(TBUFF **resp, const char *valp);
#endif
#if OPT_FINDPATH
int var_FINDCMD(TBUFF **resp, const char *valp);
int var_FINDPATH(TBUFF **resp, const char *valp);
#endif
int var_FONT(TBUFF **resp, const char *valp);
int var_FWD_SEARCH(TBUFF **resp, const char *valp);
int var_GET_AT_DOT(TBUFF **resp, const char *valp);
int var_GET_IT_ALL(TBUFF **resp, const char *valp);
int var_GET_LENGTH(TBUFF **resp, const char *valp);
int var_GET_OFFSET(TBUFF **resp, const char *valp);
#if OPT_TRACE
int var_GOAL_COLUMN(TBUFF **resp, const char *valp);
#endif
int var_HELPFILE(TBUFF **resp, const char *valp);
#if DISP_X11
int var_ICONNAME(TBUFF **resp, const char *valp);
#endif
#if OPT_CURTOKENS
int var_IDENTIFIER(TBUFF **resp, const char *valp);
#endif
#if OPT_MULTIBYTE
int var_KBD_ENCODING(TBUFF **resp, const char *valp);
#endif
int var_KBDMACRO(TBUFF **resp, const char *valp);
int var_KILL(TBUFF **resp, const char *valp);
int var_KILL_LIMIT(TBUFF **resp, const char *valp);
int var_KILL_SIZE(TBUFF **resp, const char *valp);
int var_LASTKEY(TBUFF **resp, const char *valp);
#if OPT_MULTIBYTE
int var_LATIN1_EXPR(TBUFF **resp, const char *valp);
#endif
int var_LCOLS(TBUFF **resp, const char *valp);
int var_LIBDIR_PATH(TBUFF **resp, const char *valp);
int var_LINE(TBUFF **resp, const char *valp);
int var_LLENGTH(TBUFF **resp, const char *valp);
#if OPT_LOCALE
int var_LOCALE(TBUFF **resp, const char *valp);
#endif
#if OPT_MAJORMODE
int var_MAJORMODE(TBUFF **resp, const char *valp);
#endif
#if OPT_HOOKS&&OPT_MAJORMODE
int var_MAJORMODEHOOK(TBUFF **resp, const char *valp);
#endif
int var_MATCH(TBUFF **resp, const char *valp);
#if OPT_MENUS
int var_MENU_FILE(TBUFF **resp, const char *valp);
#endif
int var_MODE(TBUFF **resp, const char *valp);
#if OPT_MLFORMAT
int var_MLFORMAT(TBUFF **resp, const char *valp);
#endif
#if OPT_MODELINE
int var_MODELINE_LIMIT(TBUFF **resp, const char *valp);
#endif
int var_MODIFIED(TBUFF **resp, const char *valp);
int var_NCOLORS(TBUFF **resp, const char *valp);
int var_NTILDES(TBUFF **resp, const char *valp);
#if OPT_SHELL
int var_OCWD(TBUFF **resp, const char *valp);
#endif
int var_OS(TBUFF **resp, const char *valp);
int var_PAGELEN(TBUFF **resp, const char *valp);
int var_CURWIDTH(TBUFF **resp, const char *valp);
int var_PALETTE(TBUFF **resp, const char *valp);
int var_PATCHLEVEL(TBUFF **resp, const char *valp);
int var_PATHCHR(TBUFF **resp, const char *valp);
#if OPT_CURTOKENS
int var_PATHNAME(TBUFF **resp, const char *valp);
#endif
int var_PATHSEP(TBUFF **resp, const char *valp);
int var_PENDING(TBUFF **resp, const char *valp);
int var_PROCESSID(TBUFF **resp, const char *valp);
#if OPT_POSFORMAT
int var_POSFORMAT(TBUFF **resp, const char *valp);
#endif
int var_PROGNAME(TBUFF **resp, const char *valp);
int var_PROMPT(TBUFF **resp, const char *valp);
int var_QIDENTIFIER(TBUFF **resp, const char *valp);
#if OPT_HOOKS
int var_RDHOOK(TBUFF **resp, const char *valp);
#endif
int var_REPLACE(TBUFF **resp, const char *valp);
#if OPT_EVAL
int var_RETURN(TBUFF **resp, const char *valp);
#endif
int var_SEARCH(TBUFF **resp, const char *valp);
int var_SEED(TBUFF **resp, const char *valp);
#if OPT_SHELL
int var_SHELL(TBUFF **resp, const char *valp);
#endif
int var_SRES(TBUFF **resp, const char *valp);
int var_STARTUP_FILE(TBUFF **resp, const char *valp);
int var_STARTUP_PATH(TBUFF **resp, const char *valp);
int var_STATUS(TBUFF **resp, const char *valp);
int var_TERM_COLS(TBUFF **resp, const char *valp);
#if OPT_MULTIBYTE
int var_TERM_ENCODING(TBUFF **resp, const char *valp);
#endif
int var_TERM_LINES(TBUFF **resp, const char *valp);
int var_TERM_RESIZES(TBUFF **resp, const char *valp);
#if OPT_TITLE
int var_TITLE(TBUFF **resp, const char *valp);
#endif
#if OPT_MULTIBYTE&&OPT_TITLE
int var_TITLE_ENCODING(TBUFF **resp, const char *valp);
#endif
#if OPT_TITLE
int var_TITLEFORMAT(TBUFF **resp, const char *valp);
#endif
int var_VERSION(TBUFF **resp, const char *valp);
#if OPT_EVAL
int var_WITHPREFIX(TBUFF **resp, const char *valp);
#endif
int var_WLINES(TBUFF **resp, const char *valp);
int var_WORD(TBUFF **resp, const char *valp);
#if OPT_HOOKS
int var_WRHOOK(TBUFF **resp, const char *valp);
#endif
#if DISP_X11&&OPT_SHELL
int var_XDISPLAY(TBUFF **resp, const char *valp);
int var_XSHELL(TBUFF **resp, const char *valp);
int var_XSHELLFLAGS(TBUFF **resp, const char *valp);
#endif

typedef int (StateFunc)(TBUFF **resultp, const char *valuep);

typedef struct {
	StateFunc *func;
	char type;
#if OPT_ONLINEHELP
	const char* help;
#endif
} StateVars;

#ifdef realdef

#undef DATA
#if OPT_ONLINEHELP
#define DATA(func,type,help) { func, type, help }
#else
#define DATA(func,type,help) { func, type}
#endif

DECL_EXTERN(const StateVars statevar_funcs[]) = {

#if OPT_EVAL
	DATA( var__STATUS,	VALTYPE_INT,	  "function's result (external)" ),
#endif
	DATA( var_ABUFNAME,	VALTYPE_STRING,	  "alternate buffer name (i.e. '#')" ),
#if OPT_HOOKS&&OPT_COLOR
	DATA( var_AUTOCOLORHOOK, VALTYPE_STRING,  "procedure to run for auto-coloring" ),
#endif
	DATA( var_BCHANGED,	VALTYPE_BOOL,	  "true if current buffer is changed" ),
	DATA( var_BCHARS,	VALTYPE_INT,	  "chars in current buffer" ),
	DATA( var_BFLAGS,	VALTYPE_STRING,	  "status flags for current buffer" ),
	DATA( var_BLINES,	VALTYPE_INT,	  "lines in current buffer" ),
#if DISP_NTWIN
	DATA( var_BRIGHTNESS,	VALTYPE_STRING,	  "intensity of normal, bold" ),
#endif
#if OPT_MULTIBYTE
	DATA( var_BUF_ENCODING, VALTYPE_STRING,	  "buffer's encoding, derived from file-encoding, buffer content and locale" ),
#endif
#if OPT_CURTOKENS
	DATA( var_BUF_FNAME_EXPR, VALTYPE_REGEX,  "buffer+fname expression" ),
#endif
#if OPT_HOOKS
	DATA( var_BUFHOOK,	VALTYPE_STRING,	  "procedure to run when entering buf" ),
#endif
#if OPT_CURTOKENS
	DATA( var_BUFNAME,	VALTYPE_STRING,	  "buffer name under cursor" ),
#endif
	DATA( var_BWINDOWS,	VALTYPE_INT,	  "windows open on current buffer" ),
	DATA( var_CBUFNAME,	VALTYPE_STRING,	  "current buffer name" ),
#if OPT_HOOKS
	DATA( var_CDHOOK,	VALTYPE_STRING,	  "procedure to run when cd'ing" ),
#endif
#if OPT_PATHLOOKUP
	DATA( var_CDPATH,	VALTYPE_STRING,	  "runtime copy of CDPATH env var" ),
#endif
	DATA( var_CFGOPTS,	VALTYPE_STRING,	  "'interesting' compiled options (comma-delimited)" ),
	DATA( var_CFNAME,	VALTYPE_STRING,	  "current file name" ),
	DATA( var_CHAR,		VALTYPE_INT,	  "current character under the cursor" ),
#if OPT_EVAL
	DATA( var_CMD_COUNT,	VALTYPE_INT,	  "repeat-counter for macros" ),
#endif
#if OPT_MULTIBYTE
	DATA( var_CMD_ENCODING, VALTYPE_ENUM,	  "terminal's encoding support" ),
#endif
#if OPT_EVAL&&OPT_PROCEDURES
	DATA( var_CMD_MOTION,	VALTYPE_STRING,	  "motion for operator" ),
#endif
#if OPT_ENCRYPT
	DATA( var_CRYPTKEY,	VALTYPE_STRING,	  "write-only encryption-key" ),
#endif
#if !SMALLER
	DATA( var_CURCHAR,	VALTYPE_INT,	  "current character index in buffer" ),
#endif
	DATA( var_CURCOL,	VALTYPE_INT,	  "current column pos of cursor" ),
	DATA( var_CURLINE,	VALTYPE_INT,	  "current line in file" ),
#if OPT_SHELL
	DATA( var_CWD,		VALTYPE_STRING,	  "current directory" ),
#endif
	DATA( var_CWLINE,	VALTYPE_INT,	  "current screen line in window" ),
	DATA( var_DEBUG,	VALTYPE_BOOL,	  "macro debugging" ),
#if OPT_SHELL
	DATA( var_DIRECTORY,	VALTYPE_STRING,	  "controls location of temp-files" ),
#endif
	DATA( var_DISCMD,	VALTYPE_BOOL,	  "display commands on command line" ),
	DATA( var_DISINP,	VALTYPE_BOOL,	  "display command line input characters" ),
#if !SMALLER
	DATA( var_EMPTY_LINES,  VALTYPE_INT,	  "tabstop to use when interpreting %C" ),
#endif
#if OPT_LOCALE
	DATA( var_ENCODING,	VALTYPE_STRING,	  "8-bit encoding associated with buffer contents" ),
#endif
	DATA( var_EOC,		VALTYPE_BOOL,	  "true if they ended the cmd with <CR>" ),
#if OPT_FINDERR
	DATA( var_ERROR_BUFFER, VALTYPE_STRING,	  "buffer to use for find-next-error" ),
	DATA( var_ERROR_EXPR,	VALTYPE_REGEX,	  "last matched error pattern" ),
	DATA( var_ERROR_MATCH,  VALTYPE_STRING,	  "last matching text for error-pattern" ),
	DATA( var_ERROR_TABSTOP, VALTYPE_INT,	  "tabstop to use when interpreting %C" ),
#endif
	DATA( var_EXEC_PATH,	VALTYPE_STRING,	  "directory where vile's executable is found" ),
	DATA( var_EXEC_SUFFIX,  VALTYPE_STRING,	  "suffix to append when looking for execable programs" ),
#if OPT_HOOKS
	DATA( var_EXITHOOK,	VALTYPE_STRING,	  "procedure to run when quitting" ),
#endif
#if SYS_WINNT
	DATA( var_FAVORITES,	VALTYPE_STRING,	  "path to favorites directory" ),
#endif
#if !SMALLER
	DATA( var_FCHANGED,	VALTYPE_BOOL,	  "true if current buffer's file is changed" ),
#endif
#if OPT_FINDERR
	DATA( var_FILENAME_EXPR, VALTYPE_REGEX,	  "regular expression for %F" ),
#endif
	DATA( var_FILENAME_IC,  VALTYPE_BOOL,	  "true if we set OPT_CASELESS" ),
#if OPT_FILTER
	DATA( var_FILTER_LIST,  VALTYPE_STRING,	  "list of builtin-filters" ),
#endif
#if OPT_FINDPATH
	DATA( var_FINDCMD,	VALTYPE_STRING,	  "shell cmd emitted via 'find' feature (debug)" ),
	DATA( var_FINDPATH,	VALTYPE_STRING,	  "directory(s) used with 'find' feature" ),
#endif
	DATA( var_FONT,		VALTYPE_STRING,	  "current font" ),
	DATA( var_FWD_SEARCH,	VALTYPE_BOOL,	  "search-direction (true if forward)" ),
	DATA( var_GET_AT_DOT,	VALTYPE_BOOL,	  "true if token must have DOT when getting $identifier, etc., from screen" ),
	DATA( var_GET_IT_ALL,	VALTYPE_BOOL,	  "true if full-token when getting $identifier, etc., from screen" ),
	DATA( var_GET_LENGTH,	VALTYPE_INT,	  "set as side-effect of getting $identifier, etc., from screen" ),
	DATA( var_GET_OFFSET,	VALTYPE_INT,	  "set as side-effect of getting $identifier, etc., from screen" ),
#if OPT_TRACE
	DATA( var_GOAL_COLUMN,  VALTYPE_INT,	  "goal-column (debug-only)" ),
#endif
	DATA( var_HELPFILE,	VALTYPE_STRING,	  "helpfile (vile.hlp)" ),
#if DISP_X11
	DATA( var_ICONNAME,	VALTYPE_STRING,	  "current icon-name" ),
#endif
#if OPT_CURTOKENS
	DATA( var_IDENTIFIER,	VALTYPE_STRING,	  "identifier under cursor" ),
#endif
#if OPT_MULTIBYTE
	DATA( var_KBD_ENCODING, VALTYPE_ENUM,	  "terminal's keyboard encoding" ),
#endif
	DATA( var_KBDMACRO,	VALTYPE_STRING,	  "keyboard-macro buffer (read only)" ),
	DATA( var_KILL,		VALTYPE_STRING,	  "kill buffer (read only)" ),
	DATA( var_KILL_LIMIT,	VALTYPE_INT,	  "maximum number of bytes to return in $kill" ),
	DATA( var_KILL_SIZE,	VALTYPE_INT,	  "number of bytes in kill buffer (read only)" ),
	DATA( var_LASTKEY,	VALTYPE_INT,	  "last keyboard char struck" ),
#if OPT_MULTIBYTE
	DATA( var_LATIN1_EXPR,  VALTYPE_REGEX,	  "regular expression matching language codes assumed to be Latin-1" ),
#endif
	DATA( var_LCOLS,	VALTYPE_INT,	  "length of current line, in columns" ),
	DATA( var_LIBDIR_PATH,  VALTYPE_STRING,	  "library directory(s)" ),
	DATA( var_LINE,		VALTYPE_STRING,	  "text of current line" ),
	DATA( var_LLENGTH,	VALTYPE_INT,	  "length of current line" ),
#if OPT_LOCALE
	DATA( var_LOCALE,	VALTYPE_STRING,	  "8-bit locale associated with buffer contents" ),
#endif
#if OPT_MAJORMODE
	DATA( var_MAJORMODE,	VALTYPE_STRING,	  "current majormode, if any" ),
#endif
#if OPT_HOOKS&&OPT_MAJORMODE
	DATA( var_MAJORMODEHOOK, VALTYPE_STRING,  "procedure to run for majormodes" ),
#endif
	DATA( var_MATCH,	VALTYPE_STRING,	  "last matched magic pattern" ),
#if OPT_MENUS
	DATA( var_MENU_FILE,	VALTYPE_STRING,	  "the name of the menu-file (e.g., .vilemenu)" ),
#endif
	DATA( var_MODE,		VALTYPE_ENUM,	  "are we inserting/overwriting/command" ),
#if OPT_MLFORMAT
	DATA( var_MLFORMAT,	VALTYPE_STRING,	  "modeline format string" ),
#endif
#if OPT_MODELINE
	DATA( var_MODELINE_LIMIT, VALTYPE_INT,	  "maximum inline offset to scan for modelines" ),
#endif
	DATA( var_MODIFIED,	VALTYPE_BOOL,	  "is current buffer modified?" ),
	DATA( var_NCOLORS,	VALTYPE_INT,	  "number of colors displayed" ),
	DATA( var_NTILDES,	VALTYPE_INT,	  "number of tildes displayed at eob" ),
#if OPT_SHELL
	DATA( var_OCWD,		VALTYPE_STRING,	  "previous directory" ),
#endif
	DATA( var_OS,		VALTYPE_STRING,	  "what os are we on?" ),
	DATA( var_PAGELEN,	VALTYPE_INT,	  "number of lines used by editor" ),
	DATA( var_CURWIDTH,	VALTYPE_INT,	  "current screen width" ),
	DATA( var_PALETTE,	VALTYPE_STRING,	  "current palette string" ),
	DATA( var_PATCHLEVEL,	VALTYPE_STRING,	  "current patch-level of vile (empty for release)" ),
	DATA( var_PATHCHR,	VALTYPE_STRING,	  "separator for lists of pathnames" ),
#if OPT_CURTOKENS
	DATA( var_PATHNAME,	VALTYPE_STRING,	  "path-like word under cursor" ),
#endif
	DATA( var_PATHSEP,	VALTYPE_STRING,	  "separator for levels of pathnames" ),
	DATA( var_PENDING,	VALTYPE_BOOL,	  "type ahead pending flag" ),
	DATA( var_PROCESSID,	VALTYPE_INT,	  "vile's process-id" ),
#if OPT_POSFORMAT
	DATA( var_POSFORMAT,	VALTYPE_STRING,	  "position format string" ),
#endif
	DATA( var_PROGNAME,	VALTYPE_STRING,	  "returns current prog name - 'vile'" ),
	DATA( var_PROMPT,	VALTYPE_STRING,	  "command-prompt string - ': '" ),
	DATA( var_QIDENTIFIER,  VALTYPE_STRING,	  "current qualified identifier" ),
#if OPT_HOOKS
	DATA( var_RDHOOK,	VALTYPE_STRING,	  "procedure to run when reading" ),
#endif
	DATA( var_REPLACE,	VALTYPE_STRING,	  "replacement pattern" ),
#if OPT_EVAL
	DATA( var_RETURN,	VALTYPE_STRING,	  "function's return-result (internal)" ),
#endif
	DATA( var_SEARCH,	VALTYPE_REGEX,	  "search pattern" ),
	DATA( var_SEED,		VALTYPE_INT,	  "current random number seed" ),
#if OPT_SHELL
	DATA( var_SHELL,	VALTYPE_STRING,	  "shell-environment variable" ),
#endif
	DATA( var_SRES,		VALTYPE_STRING,	  "current screen resolution" ),
	DATA( var_STARTUP_FILE, VALTYPE_STRING,	  "the name of the startup-file (e.g., .vilerc)" ),
	DATA( var_STARTUP_PATH, VALTYPE_STRING,	  "where to find the startup-file (e.g., .)" ),
	DATA( var_STATUS,	VALTYPE_INT,	  "returns the status of the last command" ),
	DATA( var_TERM_COLS,	VALTYPE_INT,	  "# of columns in terminal window" ),
#if OPT_MULTIBYTE
	DATA( var_TERM_ENCODING, VALTYPE_ENUM,	  "terminal's encoding support" ),
#endif
	DATA( var_TERM_LINES,	VALTYPE_INT,	  "# of lines in terminal window" ),
	DATA( var_TERM_RESIZES, VALTYPE_BOOL,	  "true if terminal can be resized" ),
#if OPT_TITLE
	DATA( var_TITLE,	VALTYPE_STRING,	  "window title" ),
#endif
#if OPT_MULTIBYTE&&OPT_TITLE
	DATA( var_TITLE_ENCODING, VALTYPE_ENUM,	  "xterm title encoding" ),
#endif
#if OPT_TITLE
	DATA( var_TITLEFORMAT,  VALTYPE_STRING,	  "window title format" ),
#endif
	DATA( var_VERSION,	VALTYPE_STRING,	  "current version number" ),
#if OPT_EVAL
	DATA( var_WITHPREFIX,	VALTYPE_STRING,	  "current '~with' prefix" ),
#endif
	DATA( var_WLINES,	VALTYPE_INT,	  "# of lines in current window" ),
	DATA( var_WORD,		VALTYPE_STRING,	  "current word" ),
#if OPT_HOOKS
	DATA( var_WRHOOK,	VALTYPE_STRING,	  "procedure to run when writing" ),
#endif
#if DISP_X11&&OPT_SHELL
	DATA( var_XDISPLAY,	VALTYPE_STRING,	  "X Windows display, etc." ),
	DATA( var_XSHELL,	VALTYPE_STRING,	  "xterm emulator, etc." ),
	DATA( var_XSHELLFLAGS,  VALTYPE_STRING,	  "$xshell flags, e.g., '-c'" ),
#endif
	DATA( (StateFunc *)NULL, 0, 0 )
};
#else
extern const StateVars statevar_funcs[];
#endif /* realdef */

extern BLIST blist_ufuncs;


/*	list of recognized macro language functions	*/

typedef enum {
	 UFABS = 0
	,UFADD
	,UFAND
	,UFASCII
	,UFBCHANGED
	,UFBIND
	,UFCAT
	,UFCCLASS
	,UFCHR
	,UFCLASSOF
	,UFCMATCH
	,UFDATE
	,UFDEFAULT
	,UFDIV
	,UFDQUERY
	,UFENV
	,UFEQUAL
	,UFERROR
	,UFEXECABLE
	,UFFCHANGED
	,UFFILTER
	,UFFTIME
	,UFGEQ
	,UFGET_COMPLETE
	,UFGET_KEY
	,UFGET_MOTION
	,UFGET_SEQ
	,UFGLOBMODE
	,UFGREATER
	,UFGT
	,UFGTKEY
	,UFGTMOTION
	,UFGTSEQ
	,UFINDIRECT
	,UFISA
	,UFLEFT
	,UFLENGTH
	,UFLEQ
	,UFLESS
	,UFLOCMODE
	,UFLOOKUP
	,UFLOWER
	,UFLT
	,UFMATCH
	,UFMCLASS
	,UFMID
	,UFMOD
	,UFNEG
	,UFNEQ
	,UFNOT
	,UFOR
	,UFPATH
	,UFPATHCAT
	,UFPATHQUOTE
	,UFQPASSWD
	,UFQUERY
	,UFRANDOM
	,UFRD
	,UFREADABLE
	,UFREGEX_ESCAPE
	,UFREGISTER
	,UFRIGHT
	,UFRND
	,UFSEQUAL
	,UFSGEQ
	,UFSGREAT
	,UFSGT
	,UFSINDEX
	,UFSLEQ
	,UFSLESS
	,UFSLT
	,UFSNEQ
	,UFSTIME
	,UFSTOKEN
	,UFSUB
	,UFTIMES
	,UFTOKEN
	,UFTRANS
	,UFTRIM
	,UFUPPER
	,UFWORD
	,UFWRITABLE

	,NFUNCS /* 82 */
} UFuncCode;

typedef struct UFUNC {
	const char *f_name;	/* name of function */
	unsigned f_code;
#if OPT_ONLINEHELP
	const char *f_help;
#endif
} UFUNC;

#define NARGMASK	0x000f
#define NUM		0x0010
#define BOOL		0x0020
#define STR		0x0040
#define NRET		0x0100
#define BRET		0x0200
#define SRET		0x0400

#ifdef realdef

#undef DATA
#if OPT_ONLINEHELP
#define DATA(name,code,help) {name,(unsigned)(code),help}
#else
#define DATA(name,code,help) {name,(unsigned)(code)}
#endif

DECL_EXTERN_CONST(UFUNC vl_ufuncs[]) = {
	DATA("abs",		1|NUM|NRET,	"absolute value of a number"),
	DATA("add",		2|NUM|NRET,	"add two numbers together"),
	DATA("and",		2|BOOL|BRET,	"logical and"),
	DATA("ascii",		1|NRET,		"char to integer conversion"),
	DATA("bchanged",	1|STR|BRET,	"return true if the given buffer has been modified"),
	DATA("bind",		1|STR|SRET,	"lookup what function name is bound to a key"),
	DATA("cat",		2|STR|SRET,	"concatenate string"),
	DATA("cclass",		1|STR|SRET,	"character-class"),
	DATA("chr",		1|NUM,		"integer to char conversion"),
	DATA("classof",		1|STR|SRET,	"class of (various types)"),
	DATA("cmatch",		2|STR|BRET,	"caseless regular expression check"),
	DATA("date",		2|NUM|SRET,	"formatted date/timestamp"),
	DATA("default",		1|STR|SRET,	"return initial/default value for mode or state-variable"),
	DATA("divide",		2|NUM|NRET,	"division"),
	DATA("dquery",		2|STR|SRET,	"query the user, given default value"),
	DATA("env",		1|STR|SRET,	"retrieve a system environment var"),
	DATA("equal",		2|NUM|BRET,	"logical equality check"),
	DATA("error",		1|STR|BRET,	"check if parameter was the ERROR token"),
	DATA("execable",	1|BRET,		"is a file executable?"),
	DATA("fchanged",	1|STR|BRET,	"return true if the given file has been modified"),
	DATA("filter",		1|STR|BRET,	"check if internal filter exists"),
	DATA("ftime",		1|STR|NRET,	"file-timestamp (last-modified)"),
	DATA("geq",		2|NUM|BRET,	"logical greater than or equal"),
	DATA("get-completion",  2|STR|SRET,	"prompt for completion from given category (b/c/d/f/t)"),
	DATA("get-key",		0,		"get 1 character"),
	DATA("get-motion",	1|STR|SRET,	"get keyboard-sequence (characters), result is motion's name"),
	DATA("get-sequence",	0,		"get keyboard-sequence (characters)"),
	DATA("global",		1|STR|SRET,	"retrieve global setting"),
	DATA("greater",		2|NUM|BRET,	"logical greater than"),
	DATA("gt",		2|NUM|BRET,	"logical greater than (greater)"),
	DATA("gtkey",		0,		"get 1 character"),
	DATA("gtmotion",	1|STR|SRET,	"get keyboard-sequence (characters), result is motion's name"),
	DATA("gtsequence",	0,		"get keyboard-sequence (characters)"),
	DATA("indirect",	1|STR|SRET,	"evaluate indirect value"),
	DATA("isa",		2|STR|BRET,	"test classification of an identifier"),
	DATA("left",		2|STR|SRET,	"left string(string, len)"),
	DATA("length",		1|NRET,		"string length"),
	DATA("leq",		2|NUM|BRET,	"logical less than or equal"),
	DATA("lessthan",	2|NUM|BRET,	"logical less than"),
	DATA("local",		1|STR|SRET,	"retrieve local setting"),
	DATA("lookup",		2|STR|SRET,	"lookup an external file"),
	DATA("lower",		1|STR|SRET,	"lower case string"),
	DATA("lt",		2|NUM|BRET,	"logical less than (lessthan)"),
	DATA("match",		2|STR|BRET,	"regular expression check"),
	DATA("mclass",		1|STR|SRET,	"mode-class"),
	DATA("middle",		3|STR|SRET,	"mid string(string, pos, len)"),
	DATA("modulo",		2|NUM|NRET,	"modulo"),
	DATA("negate",		1|NUM|NRET,	"negate"),
	DATA("neq",		2|NUM|BRET,	"logical not equal"),
	DATA("not",		1|BOOL|BRET,	"logical not"),
	DATA("or",		2|BOOL|BRET,	"logical or"),
	DATA("path",		2|STR|SRET,	"transform pathnames"),
	DATA("pcat",		2|STR|SRET,	"concat directory and filename"),
	DATA("pquote",		1|STR|SRET,	"quote pathname if needed"),
	DATA("qpasswd",		1|STR|SRET,	"query user for password, echo '*'"),
	DATA("query",		1|STR|SRET,	"query the user"),
	DATA("random",		1|NUM|NRET,	"get a random number"),
	DATA("rd",		1|BRET,		"is a file readable?"),
	DATA("readable",	1|BRET,		"is a file readable?"),
	DATA("regex-escape",	1|STR|SRET,	"escape string as needed to use as regex constant"),
	DATA("register",	1|STR|SRET,	"register, e.g. 'a'"),
	DATA("right",		2|STR|SRET,	"right string(string, pos)"),
	DATA("rnd",		1|NUM|NRET,	"get a random number"),
	DATA("sequal",		2|STR|BRET,	"string logical equality check"),
	DATA("sgeq",		2|STR|BRET,	"string greater than or equal"),
	DATA("sgreater",	2|STR|BRET,	"string logical greater than"),
	DATA("sgt",		2|STR|BRET,	"string logical greater than (sgreater)"),
	DATA("sindex",		2|NRET,		"find the index of one string in another"),
	DATA("sleq",		2|STR|BRET,	"string less than or equal"),
	DATA("sless",		2|STR|BRET,	"string logical less than"),
	DATA("slt",		2|STR|BRET,	"string logical less than (sless)"),
	DATA("sneq",		2|STR|BRET,	"string not equal"),
	DATA("stime",		0|NRET,		"system-timestamp"),
	DATA("stoken",		3|BRET,		"find a token in a string, given delims"),
	DATA("subtract",	2|NUM|NRET,	"subtraction"),
	DATA("times",		2|NUM|NRET,	"multiplication"),
	DATA("token",		3|STR|SRET,	"select n'th token of string, given delims"),
	DATA("translate",	3|STR|SRET,	"translate string, changing chars from 2nd to 3rd param"),
	DATA("trim",		1|STR|SRET,	"trims leading/trailing/repeated whitespace"),
	DATA("upper",		1|STR|SRET,	"uppercase string"),
	DATA("word",		2|STR|SRET,	"select n'th word of string"),
	DATA("writable",	1|BRET,		"is a file writeable?"),
	DATA(NULL, 0, ""),
};
#undef DATA
BLIST blist_ufuncs = init_blist(vl_ufuncs);
#else
extern const UFUNC vl_ufuncs[];
#endif


#endif /* OPT_EVAL */
